#include <sys/fd.h>
#include "struct.h"
#include "extern.h"

/******************************************************************************/
/*	Function chmod_msg() - This function is called when the IO_CHMOD message  */
/*						   is receive.  this function will change the read,   */
/*						   write and execute permissions of the driver to 	  */
/*						   what is received in the message.					  */
/* 		Parameters Passed:													  */
/*				pid :	Process ID of calling application.					  */
/******************************************************************************/
int chmod_msg(pid_t pid)
{
	struct ocb *ocb;
	
	if( (ocb = get_ocb(pid, io_msg.chmod.fd)) == (struct ocb *) (-1) )
		return(REPLY);
	
	// Need to check permissions here.
	
#if 0
	ocb->device->stat.st_mode = S_IFCHR | io_msg.chmod.mode;   /* Change access modes. */
	ocb->device->stat.st_ctime = *timep;					  /* Time of last status change.*/
	io_msg.status = EOK;
#else
	io_msg.status = EACCES;
#endif
	return(REPLY);
}
