#include <sys/fd.h>
#include "struct.h"
#include "proto.h"
#include "extern.h"

/******************************************************************************/
/*	Function chown_msg() -	This function is called when the IO_CHOWN message */
/*							is received.  This function will change the 	  */
/*							ownership of the driver to what is received in the*/
/*							message. 										  */
/*		Parameters Passed:													  */
/*				pid :	Process ID of calling application.					  */
/******************************************************************************/
int chown_msg(pid_t pid)
{
	uid_t uid;
	gid_t gid;
	struct ocb  *ocb;

	get_ids( pid, &uid, &gid );

	if( (ocb = get_ocb(pid, io_msg.chown.fd)) == (struct ocb *) (-1) )
		return(REPLY);
	
		/*
		 * ROOT  anytime
		 * OWNER (can change group, but not owner)
		 * GROUP never
		 * OTHER never
		 */

#if 0
	if(uid == 0  ||  (uid == ocb->device->stat.st_uid  &&  io_msg.chown.uid == ocb->device->stat.st_uid))
	{
		ocb->device->stat.st_uid = io_msg.chown.uid;		/* Change user ID.  */
		ocb->device->stat.st_gid = io_msg.chown.gid;		/* Change group ID. */
		ocb->device->stat.st_ctime = *timep;				/* Time of last status change.*/
		io_msg.status = EOK;
	}
	else
#endif
		io_msg.status = EACCES;

	return(REPLY);
}
