#include <stdlib.h>
#include <sys/fd.h>
#include "define.h"
#include "struct.h"
#include "extern.h"


/*******************************************************************************/
/*	Function close_msg() -	This function is called when a IO_CLOSE message is */
/*							received.  This message is sent every time a 	   */
/*							application issues a close() on the file 		   */
/*							descriptor associated with the driver.  This 	   */
/*							function will reset the adapter and allow another  */
/*							application to open the driver.					   */
/*		Parameters Passed :													   */
/*				pid :	Process ID of application calling close().			   */
/*******************************************************************************/

int close_msg(pid_t pid)
{
	struct ocb  *ocb;
	
	if( (ocb = get_ocb(pid, io_msg.close.fd)) == (struct ocb *) (-1) )
		return(REPLY);
	
	if( ! (--ocb->count) )		/* Allow another application to use the driver */
	{
		free( ocb );
	}
								// might have to map a zero where this ocb was.
	map_ocb(pid, io_msg.close.fd, NULL);

	io_msg.close_reply.status = EOK;
	return(REPLY);
}

