
#include <libc.h>
#include <sys/sendmx.h>
#include <sys/kernel.h>
#include <sys/fd.h>

#include "struct.h"
#include "extern.h"


int chdir_msg(pid_t pid)
{
	pid; 

	io_msg.open.oflag = O_RDONLY;
	if( open_msg(-1,FALSE) == REPLY && io_msg.open_reply.status == EOK )
		io_msg.open_reply.status = (dummy.fp.fattr & Q2_DIRECTORY) ? EOK : ENOTDIR;
	else
		io_msg.open_reply.status = ENOTDIR;
	return(REPLY);
}


int rewinddir_msg(pid_t pid)
{
	struct ocb  *ocb;
   
	if( (ocb = get_ocb(pid, io_msg.rewinddir.fd)) == (struct ocb *) (-1) )
		return(REPLY);
   
	if( ocb->fp.lvl == 0 )				// top level directory
	    ocb->device = &device[0];
	else
		ocb->fp.blk = 0L;

	io_msg.status = EOK;
	return(REPLY);
}


int readdir_msg(pid_t pid)
{
	struct _mxfer_entry	 mx[3];
    struct ocb			*ocb;
	struct dir_entry	 dir_entry;
	int					 num,
						 i;
	short int			 tmp;

	if( (ocb = get_ocb(pid, io_msg.readdir.fd)) == (struct ocb *) (-1) )
		return(REPLY);
   
	if( ocb->fp.lvl == 0 )				// top level directory
	{
		io_msg.readdir_reply.ndirs = 1;
		io_msg.readdir_reply.status = EOK;
   
		if(ocb->device >= &device[numdevs])
		{
			io_msg.readdir_reply.ndirs = 0;
			return(REPLY);
		}

		if(ocb->device->name[0] == 0)
		{
			io_msg.status = EBADF;
			return(REPLY);
		}
		_setmx( &mx[0], &io_msg, sizeof(io_msg.readdir_reply)-sizeof(io_msg.readdir_reply.data));
		_setmx( &mx[1], &ocb->device->stat, sizeof(struct stat));
		_setmx( &mx[2], &ocb->device->name[0], NAME_MAX+1);
		++(ocb->device);
		Replymx( pid, 3, &mx );
	}
	else
	{
		if( ocb->fp.blk == 0 )
		{
			q2_fget( &tmp, sizeof(short), &ocb->fp );
			q2_fget( &tmp, sizeof(short), &ocb->fp );
			if( tmp & 0x8000 )
				q2_fget( &tmp, sizeof(short), &ocb->fp );
		}

		num = io_msg.readdir.ndirs;
		if(num > _DIRBUF)
			num = _DIRBUF;
		for( i = 0; i < num && 
				q2_fget(&dir_entry, sizeof(dir_entry), &ocb->fp) == sizeof(dir_entry); )
		{
			if(dir_entry.fstat & Q2_USED)
			{
				strcpy( dirbuf[i].d_name, dir_entry.fname );
				load_stat( ocb->device->stat.st_dev, &dirbuf[i].d_stat, &dir_entry );
				i++;
			}
		}

		io_msg.readdir_reply.status = EOK;
		io_msg.readdir_reply.ndirs = i;
		_setmx(&mx[0], &io_msg, sizeof(io_msg.readdir_reply) - 1);
		_setmx(&mx[1], dirbuf, sizeof(struct dirent) * i);
		Replymx(pid, 2, &mx);
	}

	return(NO_REPLY);
}

