#include <sys/fd.h>
#include "struct.h"
#include "extern.h"

/*******************************************************************************/
/*	Function dup_msg() - This function is called when a IO_DUP message is sent.*/
/*						 This message is sent either when a application 	   */
/*						 directly calls the dup() function or indirectly 	   */
/*						 during a fork() operation.	This function will         */
/*                       associate the OCB currently setup for the parent to   */
/*                       the child process.                                    */
/*			Parameters Passed :												   */
/*				pid :	Process ID of process calling dup() or PID of child process.*/
/*******************************************************************************/

int dup_msg(pid_t pid)
{
	struct ocb *ocb;
	
	ocb = get_ocb(io_msg.dup.src_pid ? io_msg.dup.src_pid : pid, io_msg.dup.src_fd);
	if( ocb == (struct ocb *) (-1) )
		return(REPLY);

	map_ocb(pid, io_msg.dup.dst_fd, ocb);
	
	++ocb->count;

	io_msg.dup_reply.status = EOK;
	return(REPLY);
}
