#include <stdlib.h>
#include "struct.h"
#include "extern.h"

/*******************************************************************************/
/*	Function handle_msg() -	This function is called when the IO_HANDLE message */
/*                          is called.                                         */
/* 		Parameters Passed:														*/
/*				pid :	Process ID of calling application.						*/
/*******************************************************************************/

int handle_msg(pid_t pid)
{
	uid_t uid;
	gid_t gid;
	int index = 0;

	get_ids(pid, &uid, &gid);			/* Get egid and euid of process pid.*/
	io_msg.status = EOK;

	switch(io_msg.open.oflag)
	{
		case _IO_HNDL_CHANGE:
			if((uid != 0) && (uid != device[index].stat.st_uid))
			{
				io_msg.status = EPERM;	/* Must be super user or have equivalent euid */
				break;
			}

			open_msg( pid, TRUE );
			break;

		case _IO_HNDL_INFO:
		case _IO_HNDL_UTIME:			// ??? bug by using check_access() here
			if((check_access(pid, &device[index].stat) & S_IRWXU) == 0)
			{
				io_msg.status = EPERM;
				break;
			}

			open_msg( pid, TRUE );
			break;

		case _IO_HNDL_RDDIR:
			open_msg( pid, TRUE );
			break;

		case _IO_HNDL_LOAD:
		case _IO_HNDL_CLOAD:
			io_msg.status = ENOSYS;
			break;
	}
	return(REPLY);
}
