#include <sys/fd.h>
#include "define.h"
#include "struct.h"
#include "extern.h"

/*******************************************************************************/
/*	Function ioctl_msg() -	This function is called when a qnx_ioctl() is 	   */
/*							called from the application.  It is called when a  */
/*							IO_IOCTL message is received.  It will preform 4   */
/*							different tasks depending on the type of IO_IOCTL  */
/*							message received.  The 4 tasks are:				   */
/*        Note that the tasks performed could be anything...                   */
/*******************************************************************************/

int ioctl_msg(pid_t pid)
{
//	struct _mxfer_entry mx[2];
	struct ocb  *ocb;
	
	if( (ocb = get_ocb(pid, io_msg.ioctl.fd)) == (struct ocb *) (-1) )
		return(REPLY);
					/* Get the reset of the IOCTL message. */
//	Readmsg(pid, sizeof(io_msg.ioctl) - sizeof(io_msg.ioctl.data), &_ioctl, io_msg.ioctl.nbytes);
	switch(io_msg.ioctl.request)
	{
		default:								/* Invalid ioctl request. 						*/
			io_msg.ioctl_reply.status = EINVAL;
			io_msg.ioctl_reply.ret_val = -1;
			break;
	}
	io_msg.ioctl_reply.ret_val = 0;
	io_msg.ioctl_reply.status = EOK;
//	_setmx(&mx[0], &io_msg, sizeof(io_msg.ioctl_reply)-sizeof(io_msg.ioctl_reply.data));
//	_setmx(&mx[1], &_ioctl, sizeof(_ioctl));
//	Replymx(pid, 2, &mx);
	return(NO_REPLY);
}
