
#include <libc.h>
#include <sys/kernel.h>
#include <sys/sendmx.h>

#include "struct.h"
#include "extern.h"
#include "define.h"


int read_msg(pid_t pid)
{
	struct ocb			*ocb;
	struct _mxfer_entry	 mx_entry[3];
	int					 num;
	
	if( (ocb = get_ocb(pid, io_msg.read.fd)) == (struct ocb *) (-1) )
		return(REPLY);
	
	if((check_access(pid, &(ocb->device->stat)) & S_IREAD) == 0)
	{
		io_msg.status = EPERM;
		return(REPLY);
	}

	num = io_msg.read.nbytes;
	if( num > sizeof(buff) )
		num = sizeof(buff);

	num = q2_fget( &buff, num, &ocb->fp );

	io_msg.read_reply.nbytes = num;
	io_msg.read_reply.status = EOK;
	_setmx( &mx_entry[0], &io_msg.read_reply, sizeof(io_msg.read_reply) - 1 );
	_setmx( &mx_entry[1], buff, num );
	Replymx(pid, 2, &mx_entry);
	
	return(NO_REPLY);
}
