
#include <libc.h>
#include <sys/kernel.h>
#include <sys/sendmx.h>

#include "struct.h"
#include "extern.h"
#include "define.h"


int seek_msg(pid_t pid)
{
	struct ocb			*ocb;
	long				 offset;
	int					 num,
						 i;
	
	if( (ocb = get_ocb(pid, io_msg.lseek.fd)) == (struct ocb *) (-1) )
		return(REPLY);
	
	io_msg.lseek_reply.status = EOK;
	switch( io_msg.lseek.whence )
	{
		case SEEK_END:
			io_msg.lseek.offset = ocb->fstat.st_size - io_msg.lseek.offset;
			/* fall through */
		case SEEK_SET:
abs_seek: ;
			ocb->fp.blk = 0L;
			if( (offset = io_msg.lseek.offset) > 0 )
			{
				while( offset )
				{
					i = (offset > INT_MAX) ? INT_MAX : (int) offset;
					num = q2_fget( NULL, i, &ocb->fp );
					offset =- num;
					if( num != i )
						break;
				}								
			}
			else
				io_msg.lseek_reply.status = ENOSYS;
			break;
		case SEEK_CUR:
			if( (offset = io_msg.lseek.offset) > 0 )
			{
				while( offset )
				{
					i = (offset > INT_MAX) ? INT_MAX : (int) offset;
					num = q2_fget( NULL, i, &ocb->fp );
					offset =- num;
					if( num != i )
						break;
				}								
			}
			else
			{
				io_msg.lseek.offset = ocb->fp.roff + offset;	// (+) + (-)
				goto abs_seek;
			}
			break;
		}
	
	return( REPLY );
}
