#include <string.h>
#include <sys/fd.h>
#include "define.h"
#include "struct.h"
#include "extern.h"

/******************************************************************************/
/*	Function fstat_msg() - This function is call when the IO_FSTAT message is */
/*                         received. This function will reply with the fstat  */
/*                         structure which is kept updated throughout the     */
/*                         driver in the appropriate functions.               */
/*       Parameters Passed:                                                   */
/*          pid :  Process ID of calling application.						  */
/******************************************************************************/

int fstat_msg(pid_t pid)
{
	struct ocb  *ocb;
	
	if( (ocb = get_ocb(pid, io_msg.fstat.fd)) != (struct ocb *) (-1) )
		memcpy(&io_msg.fstat_reply.stat, &ocb->fstat, sizeof(struct stat));

	return(REPLY);
}


/******************************************************************************/
/*	Function stat_msg() - This function is called when the IO_STAT message 	  */
/*						  is received.  This function will reply with the 	  */
/*						  fstat_reply structure to the calling application.	  */
/* 		Parameters Passed:													  */
/*				pid :	Process ID of calling application.					  */
/******************************************************************************/

int stat_msg(pid_t pid)
{
	pid;
	
	if( open_msg(-1,FALSE) == REPLY && io_msg.open_reply.status == EOK )
		memcpy(&io_msg.fstat_reply.stat, &dummy.fstat, sizeof(struct stat));

	return(REPLY);
}
