#include <sys/sendmx.h>
#include <sys/kernel.h>
#include "struct.h"
#include "extern.h"

/********************************************************************************/
/*	Function sys_msg() -	This function is required to respond to system 		*/
/*							messages.  At this time it only supports the system */
/*							message subtype _SYSMSG_SUBTYPE_VERSION which is 	*/
/*							issued by the sin utility.							*/
/* 		Parameters Passed:														*/
/*				pid :	Process ID of calling application.						*/
/********************************************************************************/
int sys_msg(pid_t pid)
{
	int reply;
	struct _sysmsg_version_reply version = { "QNX2", __DATE__, 100, 'A', 0 };
	struct _mxfer_entry mx[2];

	switch(io_msg.sysmsg.subtype)
	{
		case _SYSMSG_SUBTYPE_VERSION:			/* Send driver version back to sin utility. */
			io_msg.sysmsg_reply.status = EOK;
			_setmx(&mx[0], &io_msg, sizeof(io_msg.sysmsg_reply));
			_setmx(&mx[1], &version, sizeof(version));
			Replymx(pid, 2, &mx);
			reply = NO_REPLY;
			break;

			/* The following system messages are not supported by this driver. */
		case _SYSMSG_SUBTYPE_DEATH:
		case _SYSMSG_SUBTYPE_SIGNAL:
		case _SYSMSG_SUBTYPE_TRACE:
			io_msg.sysmsg_reply.status = ENOSYS;
			reply = REPLY;
			break;
	}
	return(reply);
}
