#ifndef _LFSYS_H_
#define _LFSYS_H_

/* #include <io.h> */

/*
 * define file structure constants
 */

#define Q2_FBLK_SIZE		512
#define Q2_FBLK_BITS		9
#define Q2_FBLK_MASK		0x1FF
#define Q2_XTNT_HDR			16
#define Q2_BITMAP_BLK		2L
#define Q2_DISK_DESC_BLK	1L

/*
 * define bits in file status byte (fstat)
 */

#define Q2_FILE_MODIFIED	0x10
#define Q2_WINDOW_APP		0x20
#define Q2_USED				0x40
#define Q2_FILE_BUSY		0x80

/*
 * define operating system constants
 */

#define Q2_NCPFN			16

/*
 * Extent header
 */

struct xtnt_hdr {
	long prev_xtnt;
	long next_xtnt;
	long size_xtnt;
	long bound_xtnt;
	};

/*
 * Directory Entry
 */

struct dir_entry {
	char fstat;
	long ffirst_xtnt;
	long flast_xtnt;
	long fnum_blks;
	unsigned fnum_xtnt;
	unsigned char fowner;
	unsigned char fgroup;
	unsigned fnum_chars_free; /* No. unused chars in last block */
	long fseconds;
	unsigned char ftype;
	unsigned char fgperms;
	unsigned char fperms;
	unsigned char fattr;
	unsigned fdate[2];
	char fname[NCPFN + 1];
	};

/*
 * File format of directory
 */

struct dir_xtnt {		/* Top bit of dir_index is zero */
	unsigned parent_xtnt;
	unsigned dir_index;
	struct dir_entry directory[0];
	};

struct ext_dir_xtnt {	/* Top bit of dir_index is set */
	unsigned parent_xtnt;
	unsigned dir_index;
	unsigned ext_parent_xtnt;
	} ;

#endif _LFSYS_H_
